{Optimierungen}
 {$DEFINE Zwei} {Berechnung des zweitbesten Zugs - ermglicht selektivere Zeiteinteilung}
 {$DEFINE Endspiel} {Spezialwertungen fr spezielle Endspiele - kostet gut 1/2 KB, steigert die Spielstrke}

 {$DEFINE schnell} {etwas lngeres Programm, etwas schnellere Suche}
 {$DEFINE Komfort} {optionale UCI-Parameter und ausfhrlichere Ausgaben (z.B. Zweitzug, Suchstatistiken)}

{Sonderfunktionen}
 {.$DEFINE Varianten} {ermglicht WB/Crazyhouse-Untersttzung, bremst aber deutlich - auch im Standardschach}
 {.$DEFINE Lernen} {legt Dateien zur Erinnerung an alte Erffnungen an}

 {.$DEFINE Test} {beginnt automatisch mit Berechnungen [-> Profiling]}
 {$DEFINE Log} {erzeugt ein Ausfhrungsprotokoll [-> Debugging]}
program Feuerstein;

uses {Windows}SysUtils;

CONST B=1; S=2; L=3; T=4; D=5; K=6; {Figuren}
TYPE FigFeld = Array[0..K] OF Integer;

CONST Stop = 1; Hintergrund = 2; unendlich = 4; Hauptzugdurch = 8; {fr Zustand}
{$IFDEF Varianten} PUCI = 1; PWinBoard = 2; {fr Protokoll}
      WHintergrund = 1; WAusgabe = 2; WPassiv = 4; {fr Winboard}
      ZhWert  : FigFeld = (0, 100+64, 200, 200, 200, 400, 2048);
      HandWert: FigFeld = (0, 32, 64, 48, 80, 128, 0);
      StdWert : FigFeld {$ELSE} MatWert : FigFeld {$ENDIF} = (0, 80+64, 300, 300, 480, 900, 2048);
      KListe : Array[0..7] OF Integer = (-17, 17, -15, 15, -16, 16, -1, 1);
      SListe : Array[0..7] OF Integer = (-33, 33, -31, 31, -18, 18, -14, 14);
      MobWert: Array[1..K] OF Integer = (8, 5, 5, 3, 1, 0);
      englisch = 'pnbrqk'; Grundstellung = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1';

TYPE DBrett = Array[0..127] OF ShortInt;
     BListe = Array[0..7] OF ShortInt; {theoretisch bis zu 16 Angreifer mglich; ohne Umwandlungen: <= 10; Annahme hier: <= 8!!!}
     Bedroher = Array[0..127] OF BListe;
     PLage = ^Lage;
     Lage = RECORD {fast alles, was ber die derzeitige Position bekannt ist; die Chronik wird extern gefhrt}
              Anzug, Bewertung, EnPassant, Rochade, Zugnummer, Stillstand, Fortschritt : Integer;
              Merkwert{$IFDEF Varianten}, Bauernmaske{$ENDIF}: Int64;
              KPos{$IFDEF Endspiel}, Material{$ELSE}{$IFDEF Varianten}, Material{$ENDIF}{$ENDIF}: Array[-1..1] OF Integer;
              Br   : DBrett; {erstes Brett: Schachbrett, zweites: Bauernwerte}
              Zahl : DBrett; {Anzahl der Angreifer der jeweiligen Farbe auf das Feld; erstes Brett: schwarz, zweites: wei}
              Ursprung: Bedroher; {Ursprung der "Angreifer", in der Form X SHL 4+Y (0: schwarz, 1: wei)}
            END;
    ZugwahlR = packed RECORD Zugwort, Sortierung: Integer; END;
    Zugtyp = packed RECORD Quelle, Ziel, Erweiterung, Fortschritt: Byte; END;
    Hirnzelle = packed RECORD
                   Wert : SmallInt;
                   tief: Byte;
                   Typ : ShortInt;
                   Bestzug : Integer;
                   MW : Int64;
                 END;
    THirn = ARRAY[0..67108863] OF Hirnzelle;
    TAnalyse = ARRAY[0..1023] OF Lage;
    ZT = ARRAY[0..4095] OF Word;

VAR Chronik, Zobrist : ARRAY[0..1023] OF Int64;
    Auftrag : String;
    Erinnerung : Boolean;
    {$IFDEF Varianten} Crazyhouse : Boolean; MatWert: FigFeld; {$ENDIF}
    {$IFDEF Lernen}Name: String; Status : Integer; {$ENDIF}
    {$IFDEF Log}Log: Text; {Abruf, Lesung, }Urzeit: Integer;{$ENDIF}
    {$IFDEF Zwei} Zwei, Zweitzug, {$ENDIF}
    {$IFDEF Varianten} Protokoll, Winboard, WZeit, SZeit,{$ENDIF}
    {$IFDEF Komfort} Reduktion, Erweiterung, {$ENDIF} ZWert, Beginn, Knoten, {$IFDEF Komfort}Selektiv, gemerkt,{$ENDIF} Restzeit, Grundwert,
    Neuerung, Richtwert, LetztWert, LetztTiefe, HauptZug, HWert, Hirnmaske, Zustand : Integer;
    X : Cardinal;
    Hirn : ^THirn;
    Analyse : ^TAnalyse;

{---- Hilfsfunktionen ----}
PROCEDURE Schreib(CONST Zeile:String); forward;
PROCEDURE Kontakt; forward; PROCEDURE Warten; BEGIN Kontakt; Sleep(1) END;
(*
FUNCTION IntToStr(Wert: Integer): String;
BEGIN
  IF Wert < 0 THEN Result := '-'+IntToStr(-Wert) ELSE
  BEGIN Result := ''; REPEAT Result := Chr(Wert MOD 10+48)+Result; Wert := Wert DIV 10 UNTIL Wert = 0 END;
END;
*)
FUNCTION Wertung(Wert: Integer):String;

BEGIN
  Result := 'cp '+IntToStr(Wert);
  IF Wert >  16384 THEN Result := 'mate '+IntToStr(  (30002-Wert) SHR 1 );
  IF Wert < -16384 THEN Result := 'mate '+IntToStr(-((30001+Wert) SHR 1));
END;
(*
FUNCTION StrToInt(CONST S:String):Integer; VAR I : Integer;
BEGIN Result := 0; FOR I := 1 TO Length(S) DO Result := Result*10+Ord(S[I])-48 END;
*)
PROCEDURE Schreib(CONST Zeile:String);
(*
  PROCEDURE sende(CONST S:String); BEGIN WriteFile(GetStdHandle(std_output_handle), S[1], Length(S), X, nil) END;
*)
{$IFDEF Log} VAR Start : Integer; {$ENDIF}
BEGIN
  {$IFDEF Log} Start := Integer(GetTickCount64); {$ENDIF}
  (*
  sende(Zeile); sende(#10);
  *)
  WriteLn(Zeile);
  Flush(output);
  {$IFDEF Log} IF Integer(GetTickCount64)-Start > 500 THEN WriteLn(Log, 'Schreibvorgang seit '+IntToStr(Start-Urzeit));
  WriteLn(Log, (Integer(GetTickCount64)-Urzeit):8,' > ',Zeile); {$ENDIF}
END;

FUNCTION EntnimmBis(VAR S:String; CONST Wort: String): String;
(*
  FUNCTION Trim(CONST S: String): String;
  VAR I, L: Integer;
  BEGIN
    L := Length(S); I := 1;
    WHILE (I <= L) DO IF (S[I] <= #32) THEN Inc(I) ELSE IF (S[L] <= #32) THEN Dec(L) ELSE Break;
    Result := Copy(S, I, L - I + 1)
  END;
*)
VAR I : Integer;
BEGIN
  I := Pos(Wort+' ', S); IF I = 0 THEN I := Length(S)+1;
  Result := Copy(S, 1, I-1); S := Copy(S, I+Length(Wort), 32767);
  S := Trim(S); Result := Trim(Result);
END;

FUNCTION Entnimm(VAR S:String): String;
{$IFOPT O+}
ASM
  MOV ECX, EDX; XOR EDX, EDX; CALL EntnimmBis
END;
{$ELSE}
BEGIN
  Result := EntnimmBis(S, '')
END;
{$ENDIF}

PROCEDURE Drucke(PL: PLage);

VAR {$IFDEF Endspiel}A, {$ENDIF} X, Y, Z : Integer;
    S, St : String;

BEGIN WITH PL^ DO BEGIN
  FOR Y := 7 DOWNTO 0 DO
  BEGIN
    St := '';
    FOR X := 0 TO 7 DO
    BEGIN
      Z := Br[X SHL 4+Y]; IF Z = 0 THEN S := '.' ELSE IF Z > 0 THEN S := UpCase(englisch[Z]) ELSE S := englisch[-z];
      {$IFDEF Varianten} IF Odd(Bauernmaske SHR (X SHL 3+Y)) THEN S := '('+S+')' ELSE {$ENDIF} S := ' '+S+' ';
      St := St + S + ' ';
    END;
    Schreib(St);
  END;

  {$IFDEF Endspiel} S := 'Material:';
  FOR Y := -1 TO 1 DO
  IF Y <> 0 THEN
  BEGIN
    S := S + '   ';
    FOR X := B TO D DO
    BEGIN
      Z := (Material[Y] SHR (X SHL 2)) AND 15;
      FOR A := 1 TO Z DO IF y > 0 THEN S := S + UpCase(englisch[X]) ELSE S := S+englisch[x];
    END;
  END; {$ENDIF}
  Schreib(S); Schreib(' ');
END; END;

{----- I. Maschinenraum -----}

FUNCTION Bauer(PL: PLage; Position : Integer):Integer;

VAR Rang, Farbe, Richtung, P1, P2 : Integer;

BEGIN WITH PL^ DO BEGIN
  Result := 0; Farbe := Br[Position];
  IF Farbe = 1 THEN Rang := Position ELSE IF Farbe = -1 THEN Rang := NOT Position ELSE Exit; Rang := Rang AND 7;
  IF Rang = 1 THEN BEGIN IF (Position >= 96) OR (Position < 32) THEN Result := 12 END
  ELSE
  BEGIN
    FOR Richtung := 1 DOWNTO -1 DO IF Richtung <> 0 THEN
    BEGIN
      P1 := Position+Richtung SHL 4;
      IF P1 AND 136 = 0 THEN
      BEGIN
        P2 := P1+Richtung SHL 4;
        IF Br[P1] = Farbe THEN Inc(Result, Rang SHL 2); {Phalanx}
        Dec(P1, Farbe);
        IF Br[P1] = Farbe THEN BEGIN Inc(Result, Rang); Inc(Result, Rang); Inc(Result, Rang) END {Custos}
        ELSE IF (Br[P1] <> -Farbe) AND ((P2 AND 136 <> 0) OR (Br[P2] <> -Farbe)) {Hilfe wird nicht gehemmt}
        THEN IF Rang > 2 THEN
        BEGIN
          Dec(P1, Farbe);
          IF (Br[P1] = Farbe) THEN Inc(Result, Rang) {Auxilium}
          ELSE BEGIN Dec(P1, Farbe); IF (Rang = 4) AND ((P2 AND 136 <> 0) OR (Br[P2-Farbe] <> -Farbe))
                     AND (Br[P1] = Farbe) THEN Inc(Result, Rang) END; {Auxilium ex initio}
        END;
      END;
    END;

    IF Result = 0 THEN Result := -10; {hilfloser Bauer}
    IF Rang > 4 THEN BEGIN Inc(Result, 32); IF Rang = 6 THEN Inc(Result, 64) END; {vielleicht einfach: Inc(Result, 1 SHL Rang);}
    Dec(Position, Farbe); IF Br[Position] = Farbe THEN Dec(Result, 12); {Epigonen}
    Dec(Position, Farbe); IF Br[Position] = Farbe THEN Dec(Result, 8)
  END;
  Dec(Result, 64); Result := Result*Farbe;
END END;

FUNCTION Rex(PL : PLage; Farbe:Integer): Integer;

VAR I, J, Position, Ausweichfeld, KP : Integer;

BEGIN WITH PL^ DO BEGIN
  KP := KPos[Farbe]; Ausweichfeld := 0; Result := 0; IF (KP < 16) OR (KP >= 112) THEN Inc(Result); {A- und H-Reihe vermeiden}
  FOR I := 7 DOWNTO 0 DO
  BEGIN
    Position := KP+KListe[I];
    IF Position AND 136 = 0 THEN
    BEGIN
      J := Zahl[Farbe AND 8+Position]; Inc(Result, J);
      IF (J = 0) AND (Br[Position]*Farbe <= 0) THEN Inc(Ausweichfeld);
    END;
  END;

  IF Result < 3 THEN Result := -Result SHL 3 ELSE Result := 64-Result SHL 5;
  Dec(Result, 32 SHR Ausweichfeld);

  Position := KP+Farbe;
  IF Position AND 136 = 0 THEN
  BEGIN {Bauernschild}
    J := 0;
    IF (Position >= 16) AND (Br[Position-16] = Farbe) THEN Inc(J, 6);
    IF (Position < 112) AND (Br[Position+16] = Farbe) THEN Inc(J, 6);
    IF Br[Position] = Farbe THEN BEGIN Inc(J, 6); J := J SHL 1 END; {Mittelbauer verbindet uere Bauern und strkt damit deren Wert}
    Inc(Result, J);
  END;
END END;

PROCEDURE Wirkung(PL : PLage; Figur, Farbe, Position : Integer; Setzen, Transparenz : Boolean);
{Pflegt die Angriffstabellen und die Beweglichkeitsbewertung
 durch Aktualisierung der Wirkung von Figur und Farbe auf X, Y auf die erreichbaren Felder.
 ist Setzen=1, werden die Angriffswerte gesetzt, sonst gelscht.

 Der Parameter "Transparenz" bestimmt, ob an der Durchlssigkeit des Felds fr "Bedrohungsstrahlen" etwas gendert werden mu:
 Ist "Transparenz" gesetzt und Setzen=1  (Figur wird auf leeres Feld gesetzt), werden Bedrohungsstrahlen auf das Feld gekrzt,
 ist "Transparenz" gesetzt und Setzen=-1 (Figur wird ersatzlos entnommen), werden sie ber das Feld hinaus verlngert}

VAR Beweg, I, Fig, Quell, Farb, dx, dy : Integer;
    Q : ^Bedroher;
    Z : ^DBrett;

  PROCEDURE Setze(Ziel : Integer);
  {Setzt/lscht eine Bedrohung ausgehend von (X, Y) auf das angegebene Feld und aktualisiert die Beweglichkeits-Bewertung}
  {$IFOPT O+}

  ASM
    MOV EDX, Z; ADD EDX, EAX                {EDX := @(Z^[Ziel]);}
    MOV ECX, EAX; SHL ECX, 3; ADD ECX, Q    {ECX := @(Q^[Ziel]);}
    MOVZX EAX, byte ptr [EDX]; ADD ECX, EAX {Inc(ECX, Z^[Ziel];}
    MOV AL, Byte(Quell)                     {AL := Quell;}
  CMP Setzen, 0; JZ @negativ
    MOV byte ptr [ECX], AL                  {Q^[Ziel, Z^[Ziel]] := Quell;}
    INC byte ptr [EDX]; INC Beweg; RET
  @negativ:
    DEC byte ptr [EDX]; DEC Beweg
    MOV AH, byte ptr [ECX-1]                {AH := Q^[Ziel, Z^[Ziel]];}
  @Finde: DEC ECX; CMP byte ptr [ECX], AL; JNE @Finde
    MOV byte ptr [ECX], AH
  END;
  {$ELSE}
  VAR Anzahl : ^ShortInt;
      Qz : ^BListe;
      J : Integer;

  BEGIN
    Anzahl := @(Z^[Ziel]); Qz := @(Q^[Ziel]);
    IF Setzen THEN
    BEGIN {Die Prfung, da der Angriff noch nicht gesetzt ist, entfllt, weil "sparsam genug" aufgerufen wird}
      Qz^[Anzahl^] := Quell; Inc(Anzahl^); Assert(Anzahl^ < 8); Inc(Beweg);
    END
    ELSE
    BEGIN
      FOR J := Anzahl^-1 DOWNTO 0 DO
      BEGIN
        Assert((J <> 0) OR (Qz^[J] = Quell));
        IF Qz^[J] = Quell THEN BEGIN Dec(Anzahl^); Qz^[J] := Qz^[Anzahl^]; Break END;
      END;
      Dec(Beweg)
    END;
  END; {$ENDIF}

  PROCEDURE Schiebe(Ziel, diff: Integer);
  {$IFOPT O+}

  ASM
    PUSH EBX; MOV EBX, EDX;
    @Anfang: ADD AL, BL; TEST AL, 136; JNZ @Ende
    PUSH EAX; CALL Setze; POP EAX
    MOV ECX, PL; CMP byte ptr [ECX+EAX+Lage.Br], 0; JZ @Anfang;
    @Ende: POP EBX
  {$ELSE}
  BEGIN
    REPEAT
      Inc(Ziel, diff); IF Ziel AND 136 <> 0 THEN Break;
      Setze(Ziel)
    UNTIL PL^.Br[Ziel] <> 0
  {$ENDIF}
  END;

  PROCEDURE TestSetze(Ziel: Integer);
  {$IFOPT O+} ASM ADD EAX, Quell; TEST AL, 136; JNZ @Ende; CALL Setze; @Ende: END;
  {$ELSE} BEGIN Inc(Ziel, Quell); IF Ziel AND 136 = 0 THEN Setze(Ziel) END; {$ENDIF}

BEGIN WITH PL^ DO BEGIN {Wirkung}
  IF Transparenz THEN {Durchlssigkeit des Position-Felds anpassen}
  BEGIN
    Setzen := NOT Setzen;
    FOR Farb := 1 DOWNTO -1 DO IF Farb <> 0 THEN
    BEGIN
      Q := @Ursprung[Succ(Farb) SHL 2]; Z := @Zahl[Succ(Farb) SHL 2];
      FOR I := Z^[Position]-1 DOWNTO 0 DO
      BEGIN
        Quell := Q^[Position, I]; {Quellinformationen auslesen}
        Fig := Farb*Br[Quell]; IF (Fig < L) OR (Fig > D) THEN Continue; {nur "strahlende" Figuren}
        dx := Position SHR 4-Quell SHR 4; dy := Position AND 7-Quell AND 7;
        IF dx > 0 THEN dx := 1 ELSE {$IFOPT O+} dx := dx SHR 4 {$ELSE} IF dx <> 0 THEN dx := -1 {$ENDIF};
        IF dy > 0 THEN dy := 1 ELSE {$IFOPT O+} dy := dy SHR 4 {$ELSE} IF dy <> 0 THEN dy := -1 {$ENDIF};
        Beweg := 0; Schiebe(Position, dx SHL 4+dy); {Durchlssigkeit anpassen}
        Inc(Bewertung, Farb*Beweg*MobWert[Fig])
      END;
    END;
    Setzen := NOT Setzen;
  END;

  {Wirkung der Strahlen AUS Position anpassen}
  Beweg := 0; Quell := Position; Q := @Ursprung[Succ(Farbe) SHL 2]; Z := @Zahl[Succ(Farbe) SHL 2];
  CASE Figur OF
    B : BEGIN TestSetze(Farbe-16); TestSetze(Farbe+16) END;
    S : FOR I := 7 DOWNTO 0 DO TestSetze(SListe[I]);
    K : FOR I := 7 DOWNTO 0 DO TestSetze(KListe[I]);
  ELSE
    IF Figur <> T THEN FOR I := 3 DOWNTO 0 DO Schiebe(Quell, KListe[I]);
    IF Figur <> L THEN FOR I := 7 DOWNTO 4 DO Schiebe(Quell, KListe[I]);
  END;

  Inc(Bewertung, Farbe*Beweg*MobWert[Figur]);
END END;

FUNCTION NeuMerkWert(PL : PLage; Z: Integer; anpassen: LongBool):Int64;
{ermittelt den Merkwert nach Ausfhrung des Zugs "Z".
"anpassen" steuert, ob zugleich EnPassant-, Rochade- und Bauernmaskenwerte angepat werden}

VAR Figur, Quell, Ziel, Zielfigur, Roch, A, Anz {$IFDEF Varianten}, Bauer, Position{$ENDIF} : Integer;
    {$IFDEF Varianten} BMaske : Int64;
    M, AltM : Integer; {$ENDIF}

BEGIN
  Roch := 0;
  {$IFDEF schnell} Ziel := (Z SHR 8) AND $FF; Quell := Z AND $FF;
  {$ELSE} Ziel := Zugtyp(Z).Ziel; Quell := Zugtyp(Z).Quelle; {$ENDIF}
  Anz := Pl^.Anzug; A := Succ(Anz) SHL 2; Figur := Abs(Pl^.Br[Quell]);
  {$IFDEF Log} IF Figur = 0 THEN BEGIN Drucke(PL); Schreib('info string Figur fehlt vor Zug '+IntToStr(Z)); Halt END; {$ENDIF}
  Result := Pl^.Merkwert;

  {$IFDEF Varianten}
  IF Crazyhouse THEN
  BEGIN
    Position := Quell AND 7+(Quell SHR 4) SHL 3;
    BMaske := Pl^.Bauernmaske; M := Pl^.Material[1] SHR 4; AltM := M;
    Result := Result XOR BMaske;
    IF (Z SHR 16 <> 0) AND (Quell = 0)
    THEN Bauer := Integer(Z SHR 16 = B)
    ELSE BEGIN
      Bauer := Integer(BMaske SHR Position) AND 1;
      BMaske := BMaske AND NOT (Int64(1) SHL Position);
    END;
    Position := Ziel AND 7+(Ziel SHR 4) SHL 3;
    BMaske := (BMaske AND NOT (Int64(1) SHL Position)) OR (Int64(Bauer) SHL Position);
  END;
  {$ENDIF}

  Result := Result XOR Zobrist[15]; {Anzugwechsel}
  {$IFDEF Varianten} IF (Z SHR 16 <> 0) AND (Quell = 0) THEN
  BEGIN
    IF anpassen THEN Dec(Pl^.Material[Anz], 1 SHL ((Z SHR 16) SHL 2));
    IF Anz > 0 THEN Dec(M, 1 SHL (Pred(Z SHR 16) SHL 2));
  END
  ELSE {$ENDIF} Result := Result XOR Zobrist[Pred(Figur) SHL 7+A+Quell]; {Quellfigur entnehmen}
  IF Z SHR 16 <> 0 THEN
  BEGIN
    Figur := Z SHR 16; {ggf. umwandeln}
    {$IFDEF Endspiel} IF anpassen THEN
    {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF} Inc(Pl^.Material[Anz], 1 SHL (Figur SHL 2)-16) {$ENDIF}
  END;
  Result := Result XOR Zobrist[Pred(Figur) SHL 7+A+Ziel]; {am Ziel einsetzen, Anzug wechseln}

  IF Pl^.Br[Ziel] <> 0 {(klassisch) geschlagene Figur entnehmen}
  THEN BEGIN
    Zielfigur := Abs(Pl^.Br[Ziel]);
    IF Zielfigur = T THEN BEGIN IF Ziel = 0 THEN Roch := 4; IF Ziel = 7 THEN Roch := 1; IF Ziel = 112 THEN Roch := 8; IF Ziel = 119 THEN Roch := 2 END;
    Result := Result XOR Zobrist[Pred(Zielfigur) SHL 7+A XOR 8+Ziel];
    {$IFDEF Varianten} IF Crazyhouse THEN
    BEGIN
      IF anpassen THEN
      BEGIN
        IF Odd(Pl^.Bauernmaske SHR Position) THEN Zielfigur := B;
        Inc(Pl^.Material[Anz], 1 SHL (Zielfigur SHL 2));
      END;
      IF Anz > 0 THEN Inc(M, 1 SHL (Pred(Zielfigur) SHL 2));
    END
    ELSE {$ENDIF} {$IFDEF Endspiel} IF anpassen THEN Dec(Pl^.Material[-Anz], 1 SHL (Zielfigur SHL 2)); {$ENDIF}
  END
  ELSE IF (Figur = B) AND (Ziel AND 112 <> Quell AND 112) {en passant geschlagenen Bauern entnehmen}
       {$IFDEF Varianten} AND (Zugtyp(Z).Erweiterung = 0) {$ENDIF}
       THEN BEGIN
         Result := Result XOR Zobrist[A XOR 8+Ziel AND 112+Quell AND 7];
         {$IFDEF Varianten}
         IF Crazyhouse THEN
         BEGIN
           BMaske := BMaske AND NOT (Int64(1) SHL (Quell AND 7+(Ziel SHR 4) SHL 3));
           IF anpassen THEN Inc(Pl^.Material[Anz], 16);
           IF Anz > 0 THEN Inc(M)
         END
         ELSE {$ENDIF} {$IFDEF Endspiel} IF anpassen THEN Dec(Pl^.Material[-Anz], 16); {$ENDIF}
       END;

  IF Pl^.Enpassant AND 8 = 0 THEN
  BEGIN Result := Result XOR Zobrist[Pl^.EnPassant SHL 4]; IF anpassen THEN Pl^.EnPassant := 8; END;

  IF Figur = B THEN
    IF ((Quell-Ziel) AND 1 = 0) {$IFDEF Varianten} AND (Z SHR 16 = 0) {$ENDIF} THEN
      (* IF ((Ziel >= 16) AND (Pl^.Br[Ziel-16] = -Anz)) {en-passant-Wert nur setzen, wenn Schlagzug mglich ist}
      OR ((Ziel < 112) AND (Pl^.Br[Ziel+16] = -Anz)) THEN *)
      BEGIN IF anpassen THEN Pl^.EnPassant := Ziel SHR 4; Result := Result XOR Zobrist[Ziel AND 112] END;
  IF Figur = T THEN
    IF (Quell-Anz) AND 8 <> 0
    THEN IF Quell < 16 THEN Roch := Roch OR (1 SHL Succ(Anz)) ELSE IF Quell >= 112 THEN Roch := Roch OR (2 SHL Succ(Anz));
  IF Figur = K THEN
  BEGIN
    Roch := Roch OR (3 SHL Succ(Anz));
    IF Quell-Ziel = 32 THEN BEGIN Result := Result XOR Zobrist[432+A+Ziel AND 7]; Result := Result XOR Zobrist[384+A+Ziel AND 7] END; {lang}
    IF Ziel-Quell = 32 THEN BEGIN Result := Result XOR Zobrist[464+A+Ziel AND 7]; Result := Result XOR Zobrist[496+A+Ziel AND 7] END; {kurz}
  END;

  Roch := Roch AND Pl^.Rochade;
  IF Roch <> 0 THEN
    FOR Anz := 3 DOWNTO 0 DO
    IF Odd(Roch SHR Anz) THEN BEGIN IF anpassen THEN Pl^.Rochade := Pl^.Rochade AND NOT (1 SHL Anz); Result := Result XOR Zobrist[23+Anz SHL 3] END;

  {$IFDEF Varianten} IF Crazyhouse THEN
  BEGIN
    Result := Result XOR BMaske;
    M := M XOR AltM; FOR Bauer := 17 DOWNTO 0 DO IF Odd(M SHR Bauer) THEN Result := Result XOR Zobrist[768+Bauer];
    IF anpassen THEN Pl^.Bauernmaske := BMaske;
  END; {$ENDIF}
END;

PROCEDURE Ziehe(Ebene, Z:Integer);
{Setzt den Zug um, aktualisiert dabei
  - Angriffs- und Beweglichkeitstabellen, Stillstand, Bewertung
  - Rochademglichkeiten, EnPassant, Merkwert (ausgelagert in "NeuMerkwert")
 ACHTUNG: Nach dem Zug mu geprft werden, ob der Knig im Schach steht,
 da der Zugerzeuger das mangels aktueller Angriffstabellen noch nicht abfngt!}

VAR Figur, BMin, BMax, ZX, ZY, QX, QY, Quell, Ziel, geschlagen, dran : Integer;
    PL : PLage;

BEGIN
  PL := @(Analyse[Ebene+1]); PL^ := Analyse[Ebene];
  BMax := 0; BMin := 8;
  Quell := Zugtyp(Z).Quelle; QX := Quell SHR 4; QY := Quell AND 7;
  Ziel  := Zugtyp(Z).Ziel;   ZX := Ziel  SHR 4; ZY := Ziel  AND 7;
  WITH PL^ DO
  BEGIN
    Merkwert := NeuMerkwert(PL, Z, true);
    Inc(Stillstand); dran := Anzug; Figur := -Br[Ziel]*dran;
    {$IFDEF Log} IF (Figur < 0) OR (Figur > D) THEN BEGIN Drucke(PL); Schreib('info string Schlagversuch auf '+IntToStr(Figur)+' durch '+IntToStr(Z)); Halt END; {$ENDIF}
    geschlagen := Figur;
    IF geschlagen <> 0 THEN
    BEGIN
      Inc(Bewertung, MatWert[Figur]*dran); {Material vernichten}
      {$IFDEF Varianten} IF Crazyhouse THEN
      BEGIN
        IF Odd(Analyse[Ebene].Bauernmaske SHR (ZY+ZX SHL 3))
        THEN
        BEGIN
          Inc(Bewertung, (-32+MatWert[B]+Handwert[B] SHR ((Analyse[Ebene].Material[dran] SHR 4) AND 7))*dran);
          IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX
        END
        ELSE Inc(Bewertung, (32+MatWert[Figur]+Handwert[Figur] SHR ((Analyse[Ebene].Material[dran] SHR (Figur SHL 2)) AND 7))*dran);
      END; {$ENDIF}
      Wirkung(PL, Figur, -dran, Ziel, false, false); {Angriffswirkung der geschlagenen Figur entfernen}
      {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF} BEGIN Stillstand := 0; Dec(Fortschritt); END;
      IF Figur = B THEN
      BEGIN
        IF dran > 0 THEN Dec(Fortschritt, ZY) ELSE Dec(Fortschritt, 7-ZY);
        IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX
      END
    END
    ELSE IF (Br[Quell] = dran) AND (ZX <> QX) {$IFDEF Varianten} AND (Zugtyp(Z).Erweiterung = 0) {$ENDIF}
    THEN {en passant => gegnerischer Bauer mu entnommen werden}
    BEGIN
      IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX;
      Inc(Bewertung, MatWert[B]*dran); {Bauernmaterial vernichten}
      {$IFDEF Varianten} IF Crazyhouse THEN
        Inc(Bewertung, (-32+MatWert[B]+Handwert[B] SHR ((Analyse[Ebene].Material[dran] SHR 4) AND 7))*dran); {$ENDIF}
      Wirkung(PL, B, -dran, Ziel AND 112+QY, false, true); {Angriffs- und Transparenzwirkung des geschlagenen Bauern beseitigen}
      Br[Ziel AND 112+QY] := 0; {geschlagenen Bauern vom Brett nehmen}
      IF dran > 0 THEN Dec(Fortschritt, QY+1) ELSE Dec(Fortschritt, 8-QY);
    END;

    {$IFDEF Varianten} IF (Quell <> 0) OR (Zugtyp(Z).Erweiterung = 0) THEN
    BEGIN {$ENDIF}
      Figur := Br[Quell]*dran; Br[Quell] := 0; {Quelle entfernen}
      Wirkung(PL, Figur, dran, Quell, false, true);
      IF Figur = B THEN
      BEGIN
        IF BMin > QX THEN BMin := QX; IF BMax < QX THEN BMax := QX;
        {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF}
        BEGIN Stillstand := 0; Dec(Fortschritt, (ZY-QY)*dran) END;
        IF Z SHR 16 <> 0 THEN BEGIN Figur := Z SHR 16; Inc(Bewertung, (MatWert[Figur]-MatWert[B])*dran) END;
      END;
    {$IFDEF Varianten} END ELSE
    BEGIN
      Figur := Z SHR 16;
      Dec(Bewertung, (32+(Handwert[Figur] SHR ((Material[dran] SHR (Figur SHL 2)) AND 7)))*dran);
      IF Figur = B THEN BEGIN Inc(Bewertung, dran SHL 6); IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX END
    END; {$ENDIF}
    IF Figur = K THEN
    BEGIN
      KPos[dran] := Ziel; {Umzug notiert}
      IF Quell-Ziel = 32 THEN {lange Rochade}
      BEGIN {Turmumstellung}
        Wirkung(PL, T, dran, ZY, false, false); {Turm entfernen; in der Ecke kein Transparenzproblem}
        Wirkung(PL, T, dran, 3 SHL 4+ZY, true, true); {Turm wieder einsetzen}
        Br[3 SHL 4+ZY] := Br[ZY]; Br[ZY] := 0;
      END;
      IF Ziel-Quell = 32 THEN {kurze Rochade}
      BEGIN {Turmumstellung}
        Wirkung(PL, T, dran, 7 SHL 4+ZY, false, false); {Turm entfernen; in der Ecke kein Transparenzproblem}
        Wirkung(PL, T, dran, 5 SHL 4+ZY, true, true); {Turm wieder einsetzen}
        Br[5 SHL 4+ZY] := Br[7 SHL 4+ZY]; Br[7 SHL 4+ZY] := 0;
      END
    END;

    Br[Ziel] := Figur*dran; {Ziel (er)setzen}
    Wirkung(PL, Figur, dran, Ziel, true, geschlagen = 0); {neue Zielwirkung}

    Anzug := -dran; IF dran < 0 THEN Inc(Zugnummer); {fertig gezogen, Farbe wechselt}

    FOR QX := BMin-2 TO BMax+2 DO IF QX AND 8 = 0 THEN
      FOR QY := 1 TO 6 DO
      BEGIN
        geschlagen := QX SHL 4+QY+8;
        Dec(Bewertung, Br[geschlagen]);
        Br[geschlagen] := Bauer(PL, geschlagen-8);
        Inc(Bewertung, Br[geschlagen])
      END;
    Chronik[Zugnummer SHL 1+Succ(dran) SHR 1] := Merkwert;
  END;
END;

PROCEDURE FEN(CONST Zeile:String);

VAR Figur, I, Farbe, Position : Integer;
    PL : PLage;
    {$IFDEF Lernen} F : FILE; {$ENDIF}

BEGIN
  PL := @Analyse[0]; FillChar(PL^, SizeOf(Lage), #0);
  I := 1; Position := 7;
  WITH PL^ DO
  BEGIN
    WHILE Zeile[I] <> ' ' DO {erste Gruppe}
    BEGIN
      IF Zeile[I] = '/' THEN {$IFDEF Varianten} IF Position AND 7 = 0 THEN Position := -32768 ELSE {$ENDIF} Position := Pred(Position) AND 7
      ELSE IF Zeile[I] < #64 THEN Inc(Position, (Ord(Zeile[I])-48) SHL 4)
      ELSE
      BEGIN
        IF Zeile[I] >= #96 THEN Farbe := -1 ELSE Farbe := 1;
        Figur := Pos(Char(Byte(Zeile[I]) OR 32), englisch); IF Figur = K THEN KPos[Farbe] := Position
        ELSE BEGIN {$IFDEF Varianten} IF (NOT Crazyhouse) OR (Position < 0) THEN BEGIN {$ENDIF} {$IFDEF Endspiel} Inc(Material[Farbe], 1 SHL (Figur SHL 2)); {$ENDIF}
        {$IFDEF Varianten} Inc(I); Continue END; {$ENDIF} END;
        Br[Position] := Farbe*Figur; Inc(Bewertung, Farbe*MatWert[Figur]);
        Wirkung(PL, Figur, Farbe, Position, true, true); {Angriffstabelle mitaufbauen}
        {$IFDEF Lernen} Merkwert := Merkwert XOR Zobrist[Pred(Figur) SHL 7+Succ(Farbe) SHL 2+Position]; {$ENDIF}
        Inc(Fortschritt); IF Figur = B THEN IF Farbe > 0 THEN Inc(Fortschritt, (NOT Position) AND 7) ELSE Inc(Fortschritt, Position AND 7);
        {$IFDEF Varianten} IF (Zeile[I+1] = '~') OR (Figur = B) THEN
        BEGIN
          Bauernmaske := Bauernmaske OR ((Int64(1) SHL (Position AND 7+(Position SHR 4) SHL 3)));
          IF Zeile[I+1] = '~' THEN Inc(I);
        END; {$ENDIF}
        Inc(Position, 16)
      END;
      Inc(I)
    END;

    Inc(I); IF Zeile[I] = 'b' THEN BEGIN Anzug := -1; {$IFDEF Lernen} Merkwert := Merkwert XOR Zobrist[15]; {$ENDIF} END ELSE Anzug := 1;
    Inc(I); Inc(I); {2. Gruppe: Anzug}

    REPEAT {3. Gruppe: Rochaderechte}
      Position := Pos(Zeile[I], 'qkQK'); Inc(I); IF Position = 0 THEN Break; Dec(Position);
      Rochade := Rochade OR (1 SHL Position); {$IFDEF Lernen} Merkwert := Merkwert XOR Zobrist[23+Position SHL 3]; {$ENDIF}
    UNTIL false;

    IF Zeile[I] = ' ' THEN Inc(I);
    IF Zeile[I] = '-' THEN EnPassant := 8 ELSE {4. Gruppe: En Passant}
    BEGIN EnPassant := Ord(Zeile[I])-97; {$IFDEF Lernen} Merkwert := Merkwert XOR Zobrist[EnPassant SHL 4]; {$ENDIF} Inc(I) END;

    Inc(I); Inc(I); Stillstand := Ord(Zeile[I])-48; {5. Gruppe: Stillstand}
    Inc(I); IF Zeile[I] <> ' ' THEN BEGIN Stillstand := Stillstand*10+Ord(Zeile[I])-48; Inc(I) END;

    Inc(I); Zugnummer := StrToInt(Copy(Zeile, I, 32767));
    {hier sollte noch die Chronik ergnzt werden; das kostet zwar etwas Programmspeicherplatz,
     verhindert aber insbesondere, da die Hauptvariante auf die Ausgangsstellung rekurriert}
    FOR I := 127 DOWNTO 0 DO IF I AND 8 <> 0 THEN BEGIN Br[I] := Bauer(PL, I-8); Inc(Bewertung, Br[I]) END;
    {$IFDEF Lernen}  Name := IntToStr(Integer(Merkwert)); {$IFDEF Varianten} IF Crazyhouse THEN Name := Name + 'zh'; {$ENDIF}
    Name := Name + '.lrn'; AssignFile(F, Name);
    IF (Zugnummer = 1) AND (Status = 0) THEN
    BEGIN
      Inc(Status); {$I-} ReSet(F, 1); {$I+}
      IF IOResult = 0 THEN
      BEGIN
        BlockRead(F, Hirn[0], FileSize(F));
        {$IFDEF Komfort} gemerkt := 0; FOR I := Hirnmaske DOWNTO 0 DO IF Hirn[i].MW <> 0 THEN Inc(gemerkt); {$ENDIF}
        CloseFile(F);
      END;
    END; {$ENDIF}
  END;
END;

{----- II. Suche -----}

FUNCTION ZugName(Z: Integer):String;

BEGIN
  SetLength(Result, 5); Result[1] := #32;
  Result[3] := Chr(Z AND 7); Z := Z SHR 4; Result[2] := Chr(Z AND 7); Z := Z SHR 4;
  Result[5] := Chr(Z AND 7); Z := Z SHR 4; Result[4] := Chr(Z AND 7); Z := Z SHR 4;
  IF Z <> 0 THEN
  {$IFDEF Varianten} IF Result[3] = #0 THEN Result[3] := #15 ELSE {$ENDIF} Result := Result+englisch[Z];
  Inc(PInteger(@(Result[2]))^, 828453217);
  {$IFDEF Varianten} IF Result[3] = '@' THEN Result[2] := UpCase(englisch[Z]); {$ENDIF}
END;

FUNCTION PV(Zug: Integer):String;

VAR Ebene, I : Integer;

BEGIN
  Result := ''; Ebene := 0;
  WHILE Zug <> 0 DO
  BEGIN
    Result := Result+ZugName(Zug); Ziehe(Ebene, Zug); Inc(Ebene);
    WITH Analyse[Ebene] DO
    BEGIN
      FOR I := Ebene-1 DOWNTO 0 DO IF Analyse[I].Merkwert = Merkwert THEN Exit;
      Zug := 0; WITH Hirn[Integer(Merkwert) AND Hirnmaske] DO
      IF MW = Merkwert THEN Zug := BestZug AND $FFFFFF;
    END;
  END;
END;

FUNCTION Suche(Ebene, Tiefe, alpha, beta, erweitert : Integer; VAR Z: Integer; favorisiert : boolean; Soll: Integer): Integer;
{Wir suchen nur Zge, deren Wert ECHT grer als alpha ist; er ist gut genug, wenn er MINDESTENS den Wert beta hat.
 Man kann also nur dann davon ausgehen, da der Wert exakt ist, wenn er im INNERN des Intervalls liegt.}

  {$IFDEF Komfort} FUNCTION Statistik(Tiefe: Integer) : String;
  BEGIN
    Result := ' depth '+IntToStr(Tiefe)+' seldepth '+IntToStr(selektiv)+' nodes '+IntToStr(Knoten)
     +' nps '+IntToStr(Knoten DIV Succ((Integer(GetTickCount64)-Beginn) DIV 1000))+' hashfull '+IntToStr(gemerkt DIV (Hirnmaske DIV 1000))
  END; {$ENDIF}

  PROCEDURE Merke(W, T, NeuEbene: Integer);
  {Speichert eine Information ber die Bewertung der Stellung vor (NeuEbene=0) oder nach (NeuEbene=1) dem "jetztZug"
   diese ist eher grer als W, wenn T = 1, eher kleiner, wenn T = -1, und gleich W, wenn T = 0.}

  VAR MerkTiefe : Integer;

  BEGIN WITH Analyse[Ebene+NeuEbene], Hirn[Integer(MerkWert) AND Hirnmaske] DO BEGIN
    Merktiefe := Tiefe-erweitert; IF Merktiefe <> 0 THEN Dec(Merktiefe, NeuEbene);
    IF (Merktiefe < tief) AND ({$IFDEF Varianten} Crazyhouse OR {$ENDIF} (Zugtyp(BestZug).Fortschritt <= Analyse[0].Fortschritt)) THEN Exit;
    tief := Merktiefe; IF MW <> Merkwert THEN BEGIN IF MW = 0 THEN {$IFDEF Komfort} Inc(gemerkt); {$ENDIF} MW := Merkwert; BestZug := 0; END;
    Wert := W; Typ := T;
    IF (NeuEbene = 0) AND (Z <> 0) THEN BestZug := Z; Zugtyp(Bestzug).Fortschritt := Fortschritt;
  END END;

VAR Zugwahl : ARRAY[{$IFDEF Varianten}0..511{$ELSE}Byte{$ENDIF}] OF ZugwahlR;
    dran, Vergleich, Anfang, I, MinWert, MaxWert, Zugzahl, jetztZug, unserFavorit, Schach, J, Kp,
    X, Y, Bauernrang, Zielfigur, Figur, Ziel, X1, X2, Vorurteil, t1, t2, t3 : Integer;
    NeuMW : Int64;
    Deckung, Gegner : ^DBrett;

  PROCEDURE Notiere(Wert: Integer); {verarbeitet die Information, da jetztZug mindestens den Wert "Wert" hat}
  LABEL Ausgabe;
  VAR temp : Integer;
  BEGIN
   {$IFDEF Zwei}
    IF (Zwei <> 0) AND (Ebene = 0) AND (Z <> 0) AND ((Wert > ZWert) OR (Zweitzug = 0)) AND (jetztZug <> Z) THEN
      IF Wert > Result THEN BEGIN Zweitzug := Z; ZWert := Result END ELSE BEGIN Zweitzug := jetztZug; ZWert := Wert END; {$ENDIF}

    IF Wert > Result THEN
    BEGIN
      Z := jetztZug; Result := Wert;
      IF Wert >= beta THEN Merke(-Result, -1, 0);
      IF (Ebene = 0) AND (Zustand AND Hauptzugdurch <> 0) THEN
      BEGIN Ausgabe:
        HWert := Result;
        IF Z <> HauptZug THEN BEGIN Neuerung := Tiefe; HauptZug := Z END;
        {$IFDEF Varianten}
        IF (Protokoll = PWinboard) AND (Winboard AND WAusgabe <> 0)
        THEN Schreib(IntToStr(Tiefe)+' '+IntToStr(Wert)+' '+IntToStr((Integer(GetTickCount64)-Beginn) DIV 10)+' '+IntToStr(Knoten)+' '+PV(Z))
        ELSE IF Protokoll = PUCI THEN {$ENDIF}
        BEGIN
          Schreib('info score '+{$IFDEF Komfort}Wertung(Wert)+Statistik(Tiefe){$ELSE}'cp '+IntToStr(Wert)+' depth '+IntToStr(Tiefe)+' nodes '+IntToStr(Knoten){$ENDIF}+' pv'+PV(Z));
          {$IFDEF Komfort} Selektiv := 0; {$ENDIF}
        END;
        Richtwert := Grundwert;
        IF (Succ(Tiefe) < Letzttiefe) OR (LetztWert-HWert > 16) OR (LetztWert-HWert < -32) THEN Richtwert := Richtwert+Richtwert; {Tiefenmangel / quantitative berraschungen verarbeiten}
        IF LetztWert-HWert > 64 THEN Richtwert := Richtwert+Richtwert; {... besonders bei Katastrophen}
        IF HWert-ZWert > 16 THEN Richtwert := Richtwert+(Richtwert SHL 2) SHR (Tiefe-Neuerung); {qualitative berraschungen verarbeiten}
        IF HWert = 0 THEN Richtwert := Richtwert SHL 1; {bei Verdacht auf Unentschieden tiefer suchen}
        temp := Analyse[0].Stillstand; IF (temp > 20) AND (temp < 90) AND (LetztWert-HWert < 16) THEN Richtwert := Richtwert SHR 1; {vermutlich ereignisarme Passagen schneller spielen}
      END;
    END
    ELSE IF (Ebene = 0) AND (jetztZug = HauptZug) THEN BEGIN Hauptzug := Z; GOTO Ausgabe END; {Nachnominierung}
  END;

LABEL blockiert, illegal, nichtSuchen, fertig;

BEGIN
  IF Tiefe = 0 THEN Result := alpha ELSE Result := -32000;
  {$IFDEF schnell} IF Tiefe > 1 THEN {wenn Vorkenntnisse fehlen, erst einmal flacher suchen}
    WITH Analyse[Ebene], Hirn[Integer(Merkwert) AND Hirnmaske] DO
      IF MW <> Merkwert THEN Suche(Ebene, Pred(Tiefe)-Integer(Tiefe <> 2), alpha, beta, erweitert, Z, favorisiert, 0); {$ENDIF}

  unserFavorit := Z; Z := 0; {$IFDEF Komfort} IF Selektiv < Ebene THEN Selektiv := Ebene; {$ENDIF}
  WITH Analyse[Ebene] DO
  BEGIN
    Deckung := @Zahl; Gegner := @Zahl;
    dran := Anzug;
    IF dran > 0 THEN
      Inc(Cardinal(Deckung), 8)
    ELSE
      Inc(Cardinal(Gegner), 8);
    kp := kpos[dran]; Schach := Gegner^[kp];
    Zugzahl := 0;  {--- III.A Zuggenerator ---}
    {Erzeugt eine Liste der Pseudo-Zge: erkennt illegale Knigszge, aber prft nicht, ob eine gespiete Figur unzulssig bewegt wird}
    FOR X := 0 TO 7 DO
      FOR Y := 0 TO 7 DO
      BEGIN
        Ziel := X SHL 4+Y;
        Figur := Br[Ziel]*dran;
        IF Figur <= 0 THEN
        BEGIN {erzeuge Schlagzge mit dem Ziel "Ziel"}
          IF Figur OR Tiefe = 0 THEN Continue; {in Ruhesuche nur Schlagzge}
          Zielfigur := -Figur;
          FOR I := Deckung^[Ziel]-1 DOWNTO 0 DO
          BEGIN
            Anfang := Ursprung[Succ(dran) SHL 2+Ziel, I];
            Figur := Br[Anfang]*dran;
            IF ((Figur <> B) OR ((Zielfigur <> 0) AND (Y <> 0) AND (Y <> 7))) AND {Bauern-Spezialzge werden nicht hier, sondern unten erzeugt}
               ((Figur <> K) OR (Gegner^[Ziel] = 0)) THEN {Knig darf sich nicht in Schach begeben}
            BEGIN
              IF (Tiefe = 0) AND ((Matwert[Zielfigur] <= Soll)
              {$IFDEF schnell}OR ((MatWert[Zielfigur] <= MatWert[Figur]) AND (Gegner^[Ziel] <> 0) AND ((Deckung^[Ziel] = 1){$IFDEF Varianten} OR Crazyhouse{$ENDIF})){$ENDIF} ) THEN Continue;
              {GEBOTEN: Wirkung auf Quellfeld / alte Drohungen bercksichtigen; prfen, ob alle Gegner Knigsbindung haben}
              Zugwahl[Zugzahl].Zugwort := Ziel SHL 8+Anfang; Inc(Zugzahl);
            END;
          END;
          {$IFDEF Varianten}
          IF Crazyhouse AND (Zielfigur = 0) AND (((Schach = 0) AND ((Gegner^[Ziel] = 0) OR (Deckung^[Ziel] <> 0))) OR ((Schach = 1) AND (Gegner^[Ziel] <> 0))) THEN
            FOR Zielfigur := B TO D DO
              IF (((Material[dran] SHR (Zielfigur SHL 2)) AND 15) <> 0)
              AND ((Zielfigur <> B) OR ((Y <> 0) AND (Y <> 7))) THEN
              BEGIN Zugwahl[Zugzahl].Zugwort := Ziel SHL 8+Zielfigur SHL 16; Inc(Zugzahl) END;
          {$ENDIF}
        END
        ELSE {erzeuge Spezialzge mit der Quelle "Ziel"}
        BEGIN
          IF Figur = B THEN
          BEGIN
            Anfang := Ziel; Bauernrang := (Anfang XOR (dran SHR 1)) AND 7;
            Inc(Ziel, dran); Inc(Anfang, Ziel SHL 8); {Vorwrtszug}
            IF Bauernrang <> 6 THEN
            BEGIN
              IF Bauernrang = 4 THEN {en passant}
              BEGIN
                IF (EnPassant=X-1) AND (Br[Ziel-16] = 0) THEN BEGIN Zugwahl[Zugzahl].Zugwort := Anfang-4096; Inc(Zugzahl) END;
                IF (X <> 7) AND (EnPassant=X+1) AND (Br[Ziel+16] = 0) THEN BEGIN Zugwahl[Zugzahl].Zugwort := Anfang+4096; Inc(Zugzahl) END;
              END;
              IF (Br[Ziel] = 0) AND (Tiefe <> 0) THEN
              BEGIN {gerade Bauernzge}
                Zugwahl[Zugzahl].Zugwort := Anfang; Inc(Zugzahl);
                IF (Bauernrang = 1) AND (Br[Ziel+dran] = 0) THEN
                BEGIN Zugwahl[Zugzahl].Zugwort := Anfang+dran SHL 8; Inc(Zugzahl) END
              END
            END
            ELSE
            BEGIN
              FOR I := D DOWNTO S DO {Bauernumwandlung}
              BEGIN
                Zielfigur := Anfang+I SHL 16;
                IF Br[Ziel] = 0 THEN BEGIN Zugwahl[Zugzahl].Zugwort := Zielfigur; Inc(Zugzahl) END;
                IF (X <> 0) AND (Br[Ziel-16]*dran < 0) THEN BEGIN Zugwahl[Zugzahl].Zugwort := Zielfigur-4096; Inc(Zugzahl) END;
                IF (X <> 7) AND (Br[Ziel+16]*dran < 0) THEN BEGIN Zugwahl[Zugzahl].Zugwort := Zielfigur+4096; Inc(Zugzahl) END;
                IF Tiefe = 0 THEN Break
              END
            END
          END
          ELSE IF (Figur = K) AND (Tiefe <> 0) AND (Gegner^[Y+64] = 0) THEN {Rochade}
          BEGIN
            Bauernrang := Rochade SHR Succ(dran);
            IF (Bauernrang AND 1 <> 0) AND (Br[Y+16] = 0) AND (Br[Y+32] = 0) AND (Br[Y+48] = 0)
            AND (Gegner^[Y+32] = 0) AND (Gegner^[Y+48] = 0) THEN
            BEGIN Zugwahl[Zugzahl].Zugwort := Y SHL 8+Y+8256; Inc(Zugzahl) END;
            IF (Bauernrang AND 2 <> 0) AND (Br[Y+80] = 0) AND (Br[Y+96] = 0)
            AND (Gegner^[Y+80] = 0) AND (Gegner^[Y+96] = 0) THEN
            BEGIN Zugwahl[Zugzahl].Zugwort := Y SHL 8+Y+24640; Inc(Zugzahl) END
          END;
        END;
    END;

    {--- III.B Vorsortierung ---}
    Anfang := 0; I := ZugZahl-1; IF Zugzahl > 0 THEN BEGIN Inc(Knoten); {IF Byte(Knoten) = 0 THEN Kontakt} END; (* ! *)
    WHILE I >= Anfang DO
    BEGIN
      jetztZug := Zugwahl[I].Zugwort;
      NeuMW := NeuMerkWert(@(Analyse[Ebene]), jetztZug, false);
      FOR Vergleich := Stillstand DOWNTO 2 DO
      IF NeuMW = Chronik[Zugnummer SHL 1+(dran AND 2) SHR 1-Vergleich] THEN
      BEGIN {Zugwiederholung}
        IF (Ebene = 0) AND (jetztZug = HauptZug) THEN Zustand := Zustand OR HauptzugDurch;
        Notiere(0); IF beta <= 0 THEN Exit;
        Zugwahl[I] := Zugwahl[Anfang]; Inc(Anfang); GOTO fertig; {Zug mu nicht weiter betrachtet werden}
      END;

      Vergleich := -16384; {- III.B.1 materieller Schtzwert -}
      Ziel := Zugtyp(jetztZug).Ziel; MaxWert := Gegner^[Ziel];
      Inc(Vergleich, MatWert[Abs(Br[Ziel])]); {Schlagzug vergten}
      Inc(Vergleich, MatWert[jetztZug SHR 16]); {Umwandlung vergten}
      MinWert := MatWert[Abs(Br[jetztZug AND $FF])];
      {$IFDEF Varianten} IF Crazyhouse AND (jetztZug SHR 16 <> 0) AND (jetztZug AND $FF = 0) THEN Dec(Vergleich, 1024); {$ENDIF}
      IF Gegner^[jetztZug AND $FF] <> 0 THEN Inc(Vergleich, MinWert SHR 5); {Ausweichen gering belohnen}
      IF Maxwert <> 0 THEN Dec(Vergleich, Minwert SHR 1); {deutlich von neuen Risiken abraten}

      {$IFDEF schnell} IF (Schach <> 0) AND (EnPassant AND 8 <> 0) THEN {- III.B.2 Ausdnnen von Antworten auf Schachgebote -}
      BEGIN
        IF Byte(kp) <> Zugtyp(jetztZug).Quelle THEN {ohne auszuweichen ...}
        IF Schach <> 1 THEN GOTO illegal {... knnen wir keinem Doppelschach entgehen}
        ELSE BEGIN
          MinWert := Ursprung[dran AND 8+kp, 0]; {Einzelbedroher ...}
          IF Ziel = MinWert THEN Inc(Vergleich, 1024) {... bevorzugt schlagen}
          ELSE
          BEGIN {... notfalls blockieren}
            IF Abs(Br[MinWert]) > S THEN
            FOR J := Maxwert-1 DOWNTO 0 DO
              IF (Ursprung[dran AND 8+Ziel, J] = MinWert)
              AND ((kp AND   7-Ziel AND   7)*(Ziel AND   7-MinWert AND   7) >= 0)
              AND ((kp AND 112-Ziel AND 112)*(Ziel AND 112-MinWert AND 112) >= 0)
              THEN GOTO blockiert;
            illegal: Dec(Zugzahl); Zugwahl[I] := Zugwahl[Zugzahl]; Dec(I); Continue
          END;
        END;
      END; blockiert: {$ENDIF}

      {- III.B.3 Nutzen von Erinnerungen -}
      WITH Hirn[Integer(NeuMW) AND Hirnmaske] DO IF NeuMW = MW THEN {18% Zeitverbrauch hier}
      BEGIN
        MinWert := Wert; Dec(MinWert, MinWert DIV 16384); {Mattabstand anpassen}
        IF (Succ(tief) >= Tiefe) OR ((Typ >= 0) AND (MinWert > 16384)) THEN
        BEGIN
          IF Typ >= 0 THEN BEGIN Notiere(MinWert); IF Result >= beta THEN Exit END;
          IF (Typ <= 0) AND (((MinWert <= Result) AND ((Ebene <> 0) OR (MinWert <= ZWert))) OR (MinWert <= alpha)) THEN
          BEGIN
            Zugwahl[I] := Zugwahl[Anfang]; Inc(Anfang);
            IF (MinWert > Result) AND (MinWert <= alpha) THEN Result := MinWert; Continue
          END;
        END;
        IF Typ >= 0 THEN Vergleich := MinWert;
      END;

      IF jetztZug = unserFavorit THEN Zugwahl[I].Sortierung := 32767 ELSE Zugwahl[I].Sortierung := Vergleich;
      Dec(I); fertig:
    END
  END;

  IF {$IFDEF Komfort}(Reduktion <> 0) AND {$ENDIF} (Tiefe > 2) AND (beta < 16384) AND (Soll <> 12345) AND (Zugzahl > 12) AND (Schach = 0) AND (Ebene <> 0)
  THEN BEGIN
    J := Tiefe-3; IF J <= 0 THEN J := 1; Y := unserFavorit;
    {IF (Zugzahl > 32) OR (NOT favorisiert) OR (Suche(Ebene, J, beta-1, beta, erweitert, Y, false, 12345) >= beta) THEN {Nullzug nur testen, wenn reduzierte Suche erfolgreich}
    BEGIN
      Analyse[Ebene+1] := Analyse[Ebene]; WITH Analyse[Ebene+1] DO
      BEGIN Anzug := -dran; Merkwert := Analyse[Ebene].Merkwert XOR Zobrist[15]; EnPassant := 8; Stillstand := 0 END;
      Y := 0; Vergleich := -Suche(Ebene+1, J, -beta, Succ(-beta), 0, Y, false, 12345);
      IF (Vergleich >= beta) AND (Vergleich < 16384) THEN BEGIN Result := Vergleich; Exit END;
    END;
  END;

  {--- III.C Eigentliche Suche ---}
  WHILE Anfang < Zugzahl DO
  BEGIN
    {Zug mit bester Voreinschtzung nach vorn}
    Vergleich := -32768; Maxwert := 0;
    FOR I := Zugzahl-1 DOWNTO Anfang DO
      IF Vergleich < Zugwahl[I].Sortierung THEN BEGIN Vergleich := Zugwahl[I].Sortierung; MaxWert := I; END;
    WITH Zugwahl[MaxWert] DO BEGIN jetztZug := Zugwort; Vorurteil := Sortierung END;
    Zugwahl[MaxWert] := Zugwahl[Anfang];
    Ziehe(Ebene, jetztZug);

    WITH Analyse[Ebene+1] DO
    IF (Zahl[dran AND 8+KPos[dran]] <> 0) {illegal?}
    THEN BEGIN Dec(Zugzahl); Zugwahl[Anfang] := Zugwahl[Zugzahl]; Continue END
    ELSE IF {$IFDEF Varianten} (NOT Crazyhouse) AND {$ENDIF} (Stillstand = 100) THEN Vergleich := 0 {50-Zge-Regel}
    ELSE BEGIN
      {$IFDEF Komfort}IF {$IFDEF Varianten} (Protokoll = PUCI) AND {$ENDIF} (Ebene = 0) AND (Knoten SHR 16 <> 0)
      THEN Schreib('info currmove'+ZugName(jetztZug)+' currmovenumber '+IntToStr(Succ(Anfang))+Statistik(Tiefe));{$ENDIF}

      {- Planung von Erweiterungen -}
      X := 0; I := Tiefe; IF I <> 0 THEN Dec(I);
      IF ({$IFDEF Komfort}((Erweiterung > 1) OR (I = 0)) AND {$ENDIF} (Zahl[Succ(dran) SHL 2+KPos[-dran]] <> 0)) {Schacherweiterung}
      OR ({$IFDEF Komfort}(Erweiterung <> 0) AND {$ENDIF} (Tiefe <> 0) AND (Zugzahl = 1)) {Zwang}
      {$IFDEF Komfort}OR ((Erweiterung > 3) AND favorisiert AND (Schach <> 0) AND ((Result <= alpha) OR ((jetztZug = unserFavorit) AND (Erweiterung > 2)))){$ENDIF}
      THEN BEGIN Inc(I); Inc(X) END
      {$IFDEF Komfort} ELSE IF (Erweiterung > 2) AND favorisiert AND (Ebene <> 0) THEN
      BEGIN
        Ziel := Zugtyp(jetztZug).Ziel;
        Zielfigur := Analyse[Ebene-1].Br[Ziel]*dran;
        IF Zielfigur >= 0 THEN {frische}
        BEGIN
          MinWert := MatWert[Abs(Analyse[Ebene].Br[Ziel])]; {Beute}
          IF Gegner^[Ziel] <> 0 THEN Dec(MinWert, MatWert[Abs(Br[Ziel])]); {netto}
          IF MinWert > MatWert[Zielfigur] THEN BEGIN Inc(I); Inc(X) END;
        END
      END{$ENDIF};

      Ziel := -16384; MinWert := -beta;
      IF I = 0 THEN
      BEGIN {- Ruhesuche: Gegner darf auszhlen -}
        Vergleich := Bewertung; {- Standardbewertung = inkrementelle Bewertung + Knigssicherheit -}
        Dec(Vergleich, Rex(@Analyse[Ebene+1], -1){$IFDEF Varianten}SHL Integer(Crazyhouse){$ENDIF});
        Inc(Vergleich, Rex(@Analyse[Ebene+1], 1){$IFDEF Varianten}SHL Integer(Crazyhouse){$ENDIF});

        {$IFDEF Endspiel}
        {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF} {- Spezialbewertungen fr Endspiele -}
          FOR Zielfigur := -1 TO 1 DO IF Zielfigur <> 0 THEN
          BEGIN
            Vergleich := Vergleich*Zielfigur;
            X1 := Material[Zielfigur]; X2 := Material[-Zielfigur];
            Inc(Vergleich, (X1 SHR 8) AND 32); {Luferpaarbonus}

            IF X1 AND 255 <> 0 THEN {Freibauern gewichten}
            BEGIN
              t3 := 7; FOR J := S TO D DO Dec(t3, J*((X2 SHR (J SHL 2)) AND 15)); {Gegnermaterial bestimmt Gewicht}
              IF t3 >= 0 THEN
              BEGIN
                Ziel := 0; {bester Freibauernrang}
                FOR t1 := 0 TO 7 DO {X-Koordinate}
                BEGIN
                  Bauernrang := 6;
                  REPEAT
                    IF Zielfigur = 1 THEN J := Bauernrang ELSE J := 7-Bauernrang;
                    Inc(J, t1 SHL 4);
                    t2 := Br[J];
                    IF t2 <> 0 THEN
                    BEGIN
                      IF t2 <> Zielfigur THEN Break;
                      t2 := KPos[-Zielfigur];
                      IF (Zielfigur*(J AND 7-t2 AND 7) > Integer(dran = Zielfigur)) {vertikaler Vorsprung}
                      OR (Abs(t2 SHR 4-t1) + Bauernrang - 7 > Integer(dran = Zielfigur)) {horizontaler Abstand}
                      THEN Ziel := Bauernrang;
                    END;
                    IF (t1 > 0) AND (Br[J-16] = -Zielfigur) THEN Break;
                    IF (t1 < 7) AND (Br[J+16] = -Zielfigur) THEN Break;
                    Dec(Bauernrang);
                  UNTIL Bauernrang <= Ziel;
                END;
                Inc(Vergleich, Ziel SHL t3);
              END;
            END;

            IF (X2 = 256) OR (X2 = 512) OR (X2 = 4096) THEN {NN, N, B erreichen gegen Bauern selten mehr als Remis}
            BEGIN
              IF X1 < 256 THEN BEGIN Inc(Vergleich, 300); IF X2 = 512 THEN Inc(Vergleich, 300) END;
              IF Vergleich < 0 THEN Vergleich := -1;
            END;
            IF X1 = 0 THEN
            BEGIN
              IF X2 > 4352 THEN Dec(Vergleich, 1024) {Gegner hat Offizier oder mehr als NB}
              ELSE IF X2 AND 240 <> 0 THEN
              BEGIN {Gegner hat mindestens einen Bauern}
                FOR J := 119 DOWNTO 0 DO IF (J AND 136 = 0) AND (Br[J] = -Zielfigur) THEN
                BEGIN
                  IF (Zielfigur*(KPos[Zielfigur] AND 7) > Zielfigur*(J AND 7)+Integer(dran <> Zielfigur)) {einsamer Knig vertikal abgehngt}
                  OR ((J < 112) AND ((Br[J+16] = -Zielfigur) OR (Br[J+17] = -Zielfigur))) {zwei verbundene Bauern}
                  THEN BEGIN Dec(Vergleich, 1024); Break END;
                  Ziel := J; REPEAT Dec(Ziel, Zielfigur) UNTIL (Ziel AND 136 <> 0) OR (Br[Ziel] <> 0);
                  IF (Ziel AND 136 = 0) THEN Continue; {jemand blockiert den Bauern}
                  REPEAT Inc(Ziel, Zielfigur)
                  UNTIL (Abs(Ziel AND 7-KPos[-Zielfigur] AND 7) > 1) OR (Abs(Ziel SHR 4-KPos[-Zielfigur] SHR 4) > 1); {Ziel := letztes unsicheres Feld}
                  IF Abs(KPos[Zielfigur] SHR 4-Ziel SHR 4) > Zielfigur*(J-Ziel)+Integer(dran <> Zielfigur)
                  THEN BEGIN Dec(Vergleich, 768); Break END; {einsamer Knig horizontal abgehngt}
                END;
              END;
              IF X2 = 4352 THEN {KNBK: von gegnerischem Lufer kontrollierte Ecken sind Mattfallen}
              BEGIN
                FOR J := 119 DOWNTO 0 DO IF (J AND 136 = 0) AND (Abs(Br[J]) = L) THEN
                BEGIN
                  IF Odd(J) = Odd(J SHR 4) {Lufer auf schwarzem Feld?}
                  THEN Dec(Vergleich, Abs(KPos[Zielfigur] AND 7+KPos[Zielfigur] SHR 4-7) SHL 7)
                  ELSE Dec(Vergleich, Abs(KPos[Zielfigur] AND 7-KPos[Zielfigur] SHR 4) SHL 7);
                  Break
                END;
              END;
            END;
            IF Vergleich > 0 THEN {oft unentschiedene Positionen, in denen die Zielfigur strker scheint, abwerten}
              IF ((X2 >= 256) AND ((X1 = 4352) OR (X1 = 8192) OR (X1 = 65536))) {KmmKm*, KRKm*}
              OR ((X2 >= 65536) AND ((X1 = 65536+256) OR (X1 = 65536+4096))) THEN Vergleich := Vergleich SHR 1; {KRmKR*}
            IF (X2 AND NOT 61680 = 0) AND (Vergleich < 0) THEN {Gegner scheint strker, hat aber nur Lufer und Bauern}
            BEGIN
              {Situation 1: unser Knig kontrolliert ein Eckfeld, das alle Bauern fngt und kein gegnerischer Lufer bedrohen kann}
               IF (KPos[Zielfigur]-2*Zielfigur) AND 8 <> 0 THEN
               BEGIN
                 Ziel := KPos[Zielfigur] SHR 4;
                 IF Ziel = 1 THEN Ziel := 0; IF Ziel = 6 THEN Ziel := 7;
                 IF (Ziel = 0) OR (Ziel = 7) THEN
                 BEGIN
                   J := (X2 SHR 4) AND 15; {Bauernanzahl}
                   IF J <> 0 THEN FOR Bauernrang := 7 DOWNTO 0 DO IF Br[Ziel SHL 4+Bauernrang] = -Zielfigur THEN Dec(J);
                   IF J = 0 THEN {alle Bauern auf Zielanflug}
                   BEGIN
                     J := (X2 SHR 12) AND 15; {Luferanzahl}
                     IF J <> 0 THEN
                       FOR Bauernrang := 119 DOWNTO 0 DO
                         IF (Bauernrang AND 136 = 0) AND (Br[Bauernrang] = (-L)*Zielfigur) THEN
                           IF Odd((Bauernrang SHR 4) XOR Bauernrang XOR Ziel XOR (Zielfigur SHR 1))
                           THEN Dec(J) ELSE Break; {ungefhrlicher Lufer}

                     IF J = 0 THEN Vergleich := -((X2 SHR 3+X2 SHR 8+X2 SHR 12) AND 15); {Restmaterial trstet}
                   END;
                 END;
               END;
            END;

            (* IF (X1 = 16) AND ((X2 = 1048576) OR (X2 = 65536)) THEN {typisches Unentschieden in KPKQ, gilt jeweils erst recht in KPKR}
            BEGIN
              Ziel := KPos[Zielfigur];
              IF ((Ziel+2*Zielfigur) AND 8 <> 0) THEN
              BEGIN
                J := 0; {steht der schwache Knig neben einer der hinteren Ecken?}
                IF Ziel < 48 THEN
                BEGIN
                  IF Ziel < 16 THEN J := Abs(Br[Ziel-2*Zielfigur+16]) OR Integer(dran <> Zielfigur) {Knig soll sich nur vor den Bauern stellen, wenn die Dame schrg hinter ihm lauert}
                  ELSE IF Ziel < 32 THEN J := 1 {direkt neben ihm ist es immer sicher}
                  ELSE IF (Ziel+Zielfigur) AND 8 = 0 THEN {Ausweichposition: zwei Felder seitlich vom Bauern}
                  BEGIN
                    IF (dran <> Zielfigur) AND (Abs(Br[7*Integer(Zielfigur=1)]) <> D) THEN J := 1 {wenn die Dame kein Zugrecht hat und nicht auf dem Ziel hockt}
                    ELSE FOR Bauernrang := 2 TO 6 DO IF Abs(Br[Ziel-16-Bauernrang*Zielfigur]) = D THEN J := 16; {oder die Springerspalte deckt}
                  END;
                  Ziel := 0;
                END;
                IF Ziel >= 80 THEN
                BEGIN
                  IF Ziel >= 112 THEN J := Abs(Br[Ziel-2*Zielfigur-16]) OR Integer(dran <> Zielfigur)
                  ELSE IF Ziel >= 96 THEN J := 1
                  ELSE IF (Ziel+Zielfigur) AND 8 = 0 THEN
                  BEGIN
                    IF (dran <> Zielfigur) AND (Abs(Br[112+7*Integer(Zielfigur=1)]) <> D) THEN J := 1
                    ELSE FOR Bauernrang := 2 TO 6 DO IF Abs(Br[Ziel+16-Bauernrang*Zielfigur]) = D THEN J := 16;
                  END;
                  Ziel := 112;
                END;
                IF Zielfigur = 1 THEN Inc(Ziel, 7);
                IF (KPos[Zielfigur] = Ziel) AND (Zahl[dran AND 8+Ziel XOR 16] <> 0) AND (Zahl[dran AND 8+Ziel XOR 16-Zielfigur] <> 0) AND (dran <> Zielfigur)
                THEN Vergleich := 0 {Patt}
                ELSE IF (J <> 0) AND (Abs(Br[Ziel-Zielfigur]) = B) THEN {Bauer steht direkt vor der Zielecke}
                BEGIN
                  J := 1 SHL Abs(KPos[-Zielfigur] AND 7-Ziel AND 7)+1 SHL Abs(KPos[-Zielfigur] SHR 4-Ziel SHR 4); {Abstand des starken Knigs}
                  IF J >= 32 THEN BEGIN Vergleich := -128; IF (J >= 36) OR (X2 = 65536) THEN Vergleich := 0 END;
                END;
              END;
            END; *)
            Vergleich := Vergleich*Zielfigur;
          END; {$ENDIF}
        Vergleich := Vergleich*dran;

        IF Zahl[Succ(dran) SHL 2+KPos[-dran]] <> 0 THEN Inc(I);
        IF Vergleich < beta THEN
          IF (Vergleich <= Result) OR (Vergleich <= alpha) THEN
          BEGIN
            IF Vergleich > Result THEN IF Vergleich <= alpha THEN Result := Vergleich ELSE Result := alpha;
            IF I = 0 THEN BEGIN Merke(Vergleich, -1, 1); GOTO nichtSuchen END {Gegner steht zu gut}
          END
          ELSE MinWert := -Vergleich
        ELSE {$IFDEF Endspiel} IF (Material[1] AND 224 <> 0) AND (Material[1] AND NOT $FF <> 0) {beide haben mehr als einen Bauern und mindestens eine andere Figur}
        AND (Material[-1] AND 224 <> 0) AND (Material[-1] AND NOT $FF <> 0)
        THEN {$ENDIF} Ziel := Vergleich-beta-128; {=> Situation nicht (Endspiel-)Bonus-kritisch}
      END;

      IF Result < alpha THEN MaxWert := -alpha ELSE MaxWert := -Result;
      {$IFDEF Zwei} IF (Ebene = 0) AND (Zwei <> 0) THEN
      BEGIN {$IFNDEF Komfort} IF (Result > 16384) AND (Zwei > 1) THEN ZWert := Result; {$ENDIF} MaxWert := -ZWert END; {$ENDIF}

      Vergleich := 29998 + MaxWert; {wenn Matt gefunden, nur noch krzere Mattdistanzen erwgen}
      IF Vergleich <= 0 THEN Break; IF Vergleich < I THEN I := Vergleich;

      WITH Hirn[Integer(Merkwert) AND Hirnmaske] DO IF Merkwert = MW THEN
      BEGIN J := BestZug AND $FFFFFF; IF J <> 0 THEN Y := J END;
      Inc(MinWert, MinWert DIV 16384); Inc(MaxWert, MaxWert DIV 16384); {Mattabstand}

      IF {$IFDEF Komfort} (Reduktion > 1) AND {$ENDIF} (I > 1) AND (Vorurteil < -MaxWert) AND (Result > -16384)
      AND (Schach = 0) AND (Analyse[Ebene].Br[Zugtyp(jetztZug).Ziel] = 0)
      AND (NOT favorisiert OR ((X = 0) AND ((Zugzahl > 20) OR (Stillstand <> 0))))
      THEN Vergleich := -Suche(Succ(Ebene), Pred(I), Pred(MaxWert), MaxWert, X, Y, favorisiert, 0)
      ELSE Vergleich := 32767;
      IF Vergleich > -MaxWert THEN Vergleich := -Suche(Succ(Ebene), I, MinWert, MaxWert, X, Y, (Ebene = 0) OR (favorisiert AND (jetztZug = unserFavorit)), Ziel);
      IF Zustand AND (Stop OR Hintergrund OR unendlich) = Stop THEN Exit;
      IF Ebene = 0 THEN Zustand := Zustand OR HauptzugDurch;
      Dec(Vergleich, Vergleich DIV 16384); {Mattabstand}
    END;

    Notiere(Vergleich); IF Result >= beta THEN Exit;
    nichtSuchen: Inc(Anfang);
    IF (Ebene = 0) AND (jetztZug <> Hauptzug) AND (Integer(GetTickCount64)-Beginn > Richtwert) THEN Zustand := Zustand OR Stop;
  END;

  IF (Tiefe <> 0) AND (ZugZahl = 0) THEN
  BEGIN {sicher als Patt oder Matt erkannt}
    IF Schach <> 0 THEN Result := -30000 ELSE Result := 0;
    Merke(-Result, 0, 0)
  END ELSE
    IF Result > alpha THEN
    BEGIN
      IF (Abs(Result) < 16384) OR (Abs(Result)+Tiefe >= 29998) THEN Merke(-Result, 0, 0)
      ELSE IF Result > 0 THEN Merke(-Result, -1, 0) ELSE Merke(-Result, 1, 0)
    END ELSE IF Result < 16384 THEN Merke(-Result, 1, 0);

  IF (Tiefe > 3) {$IFDEF Varianten} OR (Crazyhouse AND (Tiefe > 1)) {$ENDIF} THEN
  BEGIN
    Vergleich := Integer(GetTickCount64)-Beginn;
    IF (Vergleich > Restzeit) OR ((HWert >= letztWert) AND (Vergleich > Richtwert SHL 1) AND (Zustand AND Hauptzugdurch = 0)) {Notbremse}
    {$IFDEF Zwei} OR ((Zwei <> 0) AND (Ebene = 0) AND (((ZWert < -16384) AND (Result > -16384)))) {$ENDIF} {erzwungener Zug}
    THEN Zustand := Zustand OR Stop;
  END;
END;

{----- III. Schnittstelle -----}

PROCEDURE Vergessen; BEGIN FillChar(Hirn[0], Succ(Hirnmaske) SHL 4, #0); {$IFDEF Komfort} gemerkt := 0; {$ENDIF} END;

PROCEDURE RechnerZug;

LABEL Anfang;

VAR St, S : String;
    Z, Rest, proZug, Suchtiefe, verbraucht, genug : Integer;
    {$IFDEF Lernen} F : File; {$ENDIF}

BEGIN
  REPEAT
    proZug := 0; Restzeit := 0; Zustand := Stop;
    {$IFDEF Test} Vergessen; FEN(Grundstellung); Auftrag := 'infinite'; Zustand := 0;
    {$ELSE} WHILE Zustand <> 0 DO Warten; {$ENDIF}
    S := Auftrag; {Drucke(@Analyse[0]);} Rest := 40; Beginn := GetTickCount64;
    WHILE S <> '' DO
    BEGIN
      St := Entnimm(S);
      IF St[1] = 'm' THEN Rest := StrToInt(Entnimm(S)); {movestogo}
      IF St[1] = 'i' THEN Zustand := Zustand OR unendlich; {infinite}
      IF St[1] = 'p' THEN Zustand := Zustand OR Hintergrund; {ponder}
      IF Analyse[0].Anzug > 0 THEN Dec(St[1], 21);
     {IF St[1] = 'b' THEN IF St[2] = 't'}
      IF (St[1] = 'b') or (St[1] = 'w') THEN IF St[2] = 't' (* ! *)
      THEN Restzeit := StrToInt(Entnimm(S)) {btime/wtime}
      ELSE proZug := StrToInt(Entnimm(S)); {binc/winc}
    END;

    IF Restzeit < 65536 THEN Restzeit := Restzeit SHR 1 ELSE Dec(Restzeit, 32768);
    Grundwert := Restzeit DIV Succ(Rest); Inc(Grundwert, proZug SHR 1); Richtwert := Grundwert;

    Knoten := 0; {$IFDEF Komfort} selektiv := 0; {$ENDIF} HauptZug := 0; Neuerung := 0; genug := 32000;
    FOR SuchTiefe := 1 TO 255 DO
    BEGIN Anfang:
      Zustand := Zustand AND NOT Hauptzugdurch; IF Suchtiefe = 1 THEN Zustand := Zustand OR Hauptzugdurch;
      {$IFDEF Zwei} ZweitZug := 0; ZWert := -32000; {$ENDIF}
      Z := Hauptzug;
      verbraucht := Suche(0, Suchtiefe, -32000, genug, 0, Z, true, -16384);
      IF verbraucht >= genug THEN BEGIN genug := verbraucht+Abs(verbraucht)+32; GOTO Anfang; END;
      genug := verbraucht+32;
      IF ((Abs(HWert) >= 29998-Suchtiefe) {$IFDEF Komfort}{$IFDEF Zwei} AND ((Zwei <= 1) OR (Abs(ZWert) >= 29998-Suchtiefe)){$ENDIF}{$ENDIF}) THEN Break;

      verbraucht := Integer(GetTickCount64)-Beginn;
      {$IFDEF Zwei} IF (Succ(Suchtiefe) >= LetztTiefe) AND (Suchtiefe > Neuerung+2) {frher Abbruch bei "ziemlich klaren" Zgen}
      AND ( (ZWert < Letztwert-192) OR ((verbraucht > Grundwert SHR 1) AND (ZWert < Letztwert-64)) )
      AND (Abs(HWert) < 512) AND (HWert > LetztWert-32) AND (HWert < LetztWert+64)
      THEN Zustand := Zustand OR Stop; {$ENDIF}
      IF ((verbraucht > Grundwert) AND (HWert > LetztWert-16)) {moderate Zeitschranken bei begrenztem Verlust}
      OR ((verbraucht > Grundwert SHL 1) AND ((HWert > LetztWert-64) OR (LetztTiefe = 255))) {Pauschale fr ersten eigenen Zug}
      OR (verbraucht > Grundwert SHL 2) THEN Zustand := Zustand OR Stop;
      IF Zustand AND (Stop OR Hintergrund OR unendlich) = Stop THEN
      BEGIN IF verbraucht > Grundwert THEN BEGIN LetztTiefe := Suchtiefe; LetztWert := HWert END; Break END;
    END;
    WHILE Zustand AND Hintergrund <> 0 DO Warten;
    IF HauptZug <> 0 THEN
    BEGIN {$IFDEF Varianten}
      IF Protokoll = PUCI THEN
      BEGIN {$ENDIF}
        St := 'bestmove'+ZugName(HauptZug); Ziehe(0, Hauptzug);
        WITH Analyse[1], Hirn[Integer(Merkwert) AND Hirnmaske] DO
          IF Merkwert = MW THEN St := St+' ponder'+ZugName(BestZug AND $FFFFFF);
        Schreib(St);
        {$IFDEF Komfort}{$IFDEF Zwei} IF ZweitZug <> 0 THEN Schreib('info string'+PV(ZweitZug)+' '+Wertung(ZWert));{$ENDIF}{$ENDIF}
      {$IFDEF Varianten} END;
      IF Protokoll = PWinboard THEN
      BEGIN Ziehe(0, Hauptzug); Schreib('move'+Zugname(Hauptzug)); Analyse[0] := Analyse[1] END; {$ENDIF}
    END;
    {$IFDEF Lernen} IF (Analyse[0].Zugnummer = 12) AND (Status = 1) THEN
    BEGIN
      Inc(Status); AssignFile(F, Name); ReWrite(F, 1);
      BlockWrite(F, Hirn[0], Succ(Hirnmaske) SHL 4);
      CloseFile(F); Vergessen;
    END; {$ENDIF}

    WITH Analyse[0] DO {$IFDEF Lernen} IF Zugnummer > 12 THEN {$ENDIF}
    {$IFDEF Komfort}
    IF (NOT Erinnerung) OR ({$IFDEF Varianten} NOT Crazyhouse AND{$ENDIF}
    ((Stillstand > 80) {$IFDEF Endspiel} OR (Material[1] = 0) OR (Material[-1] = 0){$ENDIF})) THEN Vergessen;
    {$ENDIF}
    {Beispiel: ohne Amnesie scheitert KBNK regelmig daran, da alte Planungen Stellungen wiederholen}
  UNTIL False;
END;

PROCEDURE Hirnvolumen(MB : Integer);
VAR I : Integer;
BEGIN
  I := 1; WHILE I <= MB DO I := I SHL 1; I := I SHL 15; Hirnmaske := Pred(I);
  IF Hirn <> NIL THEN FreeMem(Hirn); GetMem(Hirn, I SHL 4); Vergessen;
END;

PROCEDURE Kontakt;

  PROCEDURE Setze({$IFNDEF Varianten}CONST{$ENDIF} S:String);
  VAR Z : Cardinal;
  BEGIN
    {$IFDEF Varianten} IF S[2] = '@' THEN BEGIN S := S+Char(Byte(S[1]) OR 32); PWord(@(S[1]))^ := 12641 END; {$ENDIF}
    Z := Ord(S[1]) SHL 4+Ord(S[2])+Ord(S[3]) SHL 12+Ord(S[4]) SHL 8-411457;
    IF Odd(Length(S)) THEN Inc(Zugtyp(Z).Erweiterung, Pos(S[5], englisch));
    Ziehe(0, Z); Analyse[0] := Analyse[1]
  END;

VAR Befehl, Kommando, S, T: String;
(*
    gelesen : Cardinal;
    C : Char;
*)
BEGIN
  (*
  {$IFDEF Log}
  IF Integer(GetTickCount64)-Abruf > 500 THEN Schreib('info string Abrufspanne '+IntToStr(Integer(GetTickCount64)-Abruf)+'ms');
  IF Integer(GetTickCount64) = Abruf THEN Exit;
  Abruf := Integer(GetTickCount64); {$ENDIF}
  PeekNamedPipe(GetStdHandle(std_input_handle), @C, 1, @gelesen, nil, nil); IF gelesen = 0 THEN Exit;
  {$IFDEF Log} IF Integer(GetTickCount64)-Abruf > 500 THEN Schreib('info string Abruf seit '+IntToStr(Integer(GetTickCount64)-Urzeit)); {$ENDIF}
  Befehl := '';
  REPEAT
    {$IFDEF Log} Lesung := Integer(GetTickCount64); {$ENDIF}
    ReadFile(GetStdHandle(std_input_handle), C, 1, gelesen, nil);
    {$IFDEF Log} IF Integer(GetTickCount64)-Lesung >= 32 THEN Schreib('info string '+IntToStr(Integer(GetTickCount64)-Lesung)+'ms nach '+Befehl); {$ENDIF}
    Befehl := Befehl+C;
  UNTIL C = #10;
  *)
  ReadLn(Befehl);
  {$IFDEF Log} WriteLn(Log, (Integer(GetTickCount64)-Urzeit):8,' < ',Befehl); {$ENDIF}
  Kommando := Entnimm(Befehl); IF Kommando = '' THEN Exit;
  IF Kommando[1] = 'q' {quit} THEN {$IFDEF Log} BEGIN CloseFile(Log); Halt; END; {$ELSE} Halt; {$ENDIF}
  IF Kommando = 'uci' THEN
  BEGIN
    Schreib({$IFDEF Komfort}'id name Feuerstein 0.4.6.1'{$IFDEF Varianten}+' VARIANT'{$ENDIF}+#10+'id author Fritz Grau'#10+{$ENDIF}
       'option name Hash type spin default 32 min 1 max 512'#10+
{$IFDEF Komfort}{$IFDEF Zwei}'option name 2nd type combo default on '+
       'var full var on var off'#10+{$ENDIF}
       'option name memory type check default true'#10+
       'option name extend type spin default 2 min 0 max 5'#10+
       'option name reduce type spin default 2 min 0 max 2'#10+
       'option name Ponder type check default true'#10+{$ENDIF}'uciok');
    {$IFDEF Varianten} Protokoll := PUCI; MatWert := StdWert; {$ENDIF}
  END;
  {$IFDEF Varianten} IF Kommando = 'xboard' THEN BEGIN Protokoll := PWinboard; WinBoard := 0; END;

  IF Protokoll = PUCI THEN {$ENDIF}
  CASE Length(Kommando) OF
    2 : BEGIN Auftrag := Befehl; Zustand := 0 END; {go}
    4 : Zustand := Stop; {'stop', denn 'quit' wird zentral oben behandelt}
    7 : Schreib('readyok'); {isready}
    8 : BEGIN {position, nicht register}
          S := EntnimmBis(Befehl, 'moves');
          IF S[1] = 's' {startpos} THEN FEN(Grundstellung) ELSE BEGIN Entnimm(S); {Result = 'fen'} FEN(S) END;
          WHILE Befehl <> '' DO BEGIN T := Entnimm(Befehl); Setze(T) END;
        END;
    9 : IF Kommando[1] = 'p' {ponderhit} THEN Zustand := Zustand AND NOT (Hintergrund OR unendlich)
        ELSE BEGIN {setoption}
          Entnimm(Befehl); {Result = 'name'}
          S := EntnimmBis(Befehl, 'value');
          IF S[1] = 'H' THEN Hirnvolumen(StrToInt(Befehl)); {Hash}
          {$IFDEF Komfort} {$IFDEF Zwei} IF S[1] = '2' THEN Zwei := (6-Length(Befehl)) MOD 3; {$ENDIF} {2}
          IF S[1] = 'm' THEN BEGIN Erinnerung := false; IF Befehl[1] = 't' THEN Erinnerung := True END; {memory}
          IF S[1] = 'r' THEN Reduktion := StrToInt(Befehl); {reduce}
          IF S[1] = 'e' THEN Erweiterung := StrToInt(Befehl); {extend} {$ENDIF}
        END;
    10: BEGIN Vergessen; Letztwert := 0; LetztTiefe := 255; {$IFDEF Lernen} Status := 0; {$ENDIF} END; {ucinewgame}
  END;

  {$IFDEF Varianten} IF Protokoll = PWinBoard THEN
  BEGIN
    IF (Length(Kommando) >= 4) AND (Kommando[4] >= '1') AND (Kommando[4] <= '8')
    THEN BEGIN Befehl := Kommando; Kommando := 'usermove' END;

    IF Kommando = 'post' THEN Winboard := Winboard OR WAusgabe ELSE IF Kommando = 'nopost' THEN Winboard := Winboard AND NOT WAusgabe
    ELSE IF Kommando = 'hard' THEN Winboard := Winboard OR WHintergrund ELSE IF Kommando = 'easy' THEN Winboard := Winboard AND NOT WHintergrund
    ELSE IF Kommando = 'force' THEN Winboard := Winboard OR WPassiv
    ELSE IF (Kommando = 'time') OR (Kommando = 'otim') THEN
    BEGIN
      IF (Kommando[1] = 'o') XOR (Analyse[0].Anzug = -1)
      THEN WZeit := StrToInt(Befehl)*10 ELSE SZeit := StrToInt(Befehl)*10
    END
    ELSE IF Kommando = 'new' THEN
    BEGIN
      Winboard := Winboard AND NOT WPassiv; {$IFDEF Lernen} Status := 0; {$ENDIF}
      MatWert := StdWert; Vergessen; FEN(Grundstellung);
      Letztwert := 0; {$IFDEF Varianten} Crazyhouse := false; {$ENDIF}
    END
    ELSE IF Kommando = 'variant' THEN
    BEGIN
      IF Befehl = 'crazyhouse' THEN
      BEGIN
        Crazyhouse := true; MatWert := ZhWert;
        {$IFDEF Lernen} Status := 0; {$ENDIF} Vergessen; FEN(Grundstellung); Letztwert := 0; Winboard := Winboard AND NOT WPassiv;
      END;
    END
    ELSE IF Kommando = 'setboard' THEN FEN(Befehl)
    ELSE IF Kommando = 'go' THEN BEGIN Winboard := Winboard AND NOT WPassiv; Auftrag := 'wtime '+IntToStr(WZeit)+' btime '+IntToStr(SZeit); Zustand := 0 END
    ELSE IF Kommando = 'protover' THEN Schreib('feature myname="Feuerstein" colors=0 usermove=1 setboard=1 analyze=1 done=1')
    ELSE IF Kommando = 'analyze' THEN BEGIN Auftrag := 'infinite'; Zustand := 0 END
    ELSE IF Kommando = 'exit' THEN Zustand := Stop
    ELSE IF Kommando = 'usermove' THEN
    BEGIN Setze(Befehl); IF Winboard AND WPassiv = 0 THEN BEGIN Auftrag := 'wtime '+IntToStr(WZeit)+' btime '+IntToStr(SZeit); Zustand := 0 END END
    ELSE IF (Kommando <> 'accepted') AND (Kommando <> 'random') AND (Kommando <> 'xboard') AND (Kommando <> 'computer') THEN Schreib('unknown command: '+Kommando);
  END; {$ENDIF}
END;

BEGIN
  {$IFDEF Log} Urzeit := Integer(GetTickCount64); AssignFile(Log, 'feuerstein.log'); ReWrite(Log); {Abruf := Urzeit;} {$ENDIF}
  Hirn := nil; Hirnvolumen(32); New(Analyse);
  FOR X := 4095 DOWNTO 0 DO ZT(Zobrist)[X] := Random(65536);
  {$IFDEF Zwei} Zwei := 1; {$ENDIF}
  {$IFDEF Komfort} Reduktion := 2; Erweiterung := 2; Erinnerung := True; {$ENDIF}
  {$IFDEF Varianten} Protokoll := 0; Crazyhouse := false; {$ENDIF}
  Rechnerzug
END.
